# -----------------------------------------------------------------------------
sub oraUp
# -----------------------------------------------------------------------------
# Changes
#   BB 20Dec04 - Added sw_version_num variable
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  if ($t_mustbeup[$thishost] eq "Y")
  {
    $eventsev = "C";
    $restart_flag = "Y"
  }
  else
  {
    $eventsev = "I";
    $restart_flag = "N"
  }

  if (! $arclog_by_dest[$thishost])
  {
    if ($t_dfcount_pct_w[$thishost] eq "") { $t_dfcount_pct_w[$thishost] = "70" }
    if ($t_dfcount_pct_c[$thishost] eq "") { $t_dfcount_pct_c[$thishost] = "75" }
  }

  if ($prevent_db_restart[$thishost] eq "Y")
  {
    $restart_flag = "N"
  }
  #print "restart_flag=$restart_flag runmon[$thishost]=$runmon[$thishost] t_mustbeup[$thishost]=$t_mustbeup[$thishost] prevent_db_restart[$thishost]=$prevent_db_restart[$thishost]\n";

  # Start with a clean slate
  $up[$thishost] = "";

  $this_fs_check_mask = $fs_check_mask[$thishost];
  $this_fs_check_mask = "." if $this_fs_check_mask eq "";
 
  $must_connect = 1;
  #remsh("$probe[$thishost] up $t_mustbeup[$thishost] $id3[$thishost]",$tmpfl3,$thishost);
  &remsh("$probe[$thishost] up $restart_flag $id3[$thishost] $this_fs_check_mask $runmon[$thishost]",$tmpfl3,$thishost);

  #See if auto-inhibit occured
  if ($up[$thishost] eq "I")
  {
    &logit("(Auto-Inhibited)",$thishost);
    return;
  }

  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return; 
  }

  #---- bb 11Apr05
  if ($up[$thishost] eq "D")
  {
    &logit("(No software download)",$thishost);
    system("echo '' | dbamon_mailer -s 'DBAmon oraUp() $titleraw[$thishost] up=D' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
    return;
  }

  system("cp $tmpfl3 /tmp/dbamondebug_$mode");
  ##system("cat $tmpfl3");

  $sqlworks="?";

  $numpmon="?";
  $numsmon="?";
  $numioslave="?";
  $numioslave_pct="?";

  $dbstarted="?";

  $landisplay = "";
  $corruption_details = ""; 

  $oraSaveCfgStack[$thishost] = "";
  $oraBkupStack[$thishost] = "";
  $oraLsnrStack[$thishost] = "";
  $oraDatafilesStack[$thishost] = "";
  $oraAlertsStack[$thishost] = "";

  $autoextend_cnt[$thishost] = "";

  $diagLsnrStack[$thishost] = "";

  $oraAlertsStack[$thishost] = "";
  $oraAuditSesStack[$thishost] = "";

  $sw_patchcount[$thishost] = 0;
  $cronlines[$thishost] = "";
  $asm[$thishost] = "";

  $maxprocesses = 0;
  $maxprocesscnt = "";

  $f_current = ""; 
  $f_config  = ""; 
  $f_pct = ""; 
  $f_sev = ""; 

  $diagLsnrStackFlag = 0;

  $mr_age[$thishost] = 99999996;
  $mr_age_arc[$thishost] = -1;
  $mr_age_file[$thishost] = -1;

  $bufhitratio[$thishost] = -1;
  $bufhitratio_xr[$thishost] = -1;
  $libhitratio[$thishost] = -1;
  $dicthitratio[$thishost] = -1;
  $bufcongets[$thishost] = -1;
  $bufblkgets[$thishost] = -1;

  $rmt_netalias_list[$thishost] = "";
  $rmt_hostname[$thishost] = "";

  $bkup_sched_arc[$thishost]  = ""; 
  $bkup_sched_lvl[$thishost]  = ""; 

  $mts_queue[$thishost] = "";
  $sys_analyzed[$thishost] = "";
  $undo_mgmt[$thishost] = "";
  $force_logging[$thishost] = "";

  $ts_exceptions[$thishost] = "";
  $user_exceptions[$thishost] = "";

  $num_cron[$thishost] = "";

  $num_otrace[$thishost] = "";
  $sql_trace[$thishost] = "";

  $os_nuserproc[$thishost] = "";
  $os_nuserproc_pct[$thishost] = "";
  $os_maxuprc[$thishost] = "";

  $df_temp_ts[$thishost] = "";
  $df_perm_ts[$thishost] = "";

  $dbstatus[$thishost] = "";
  $cftype[$thishost] = "";

  $complexpw[$thishost] = "";
  $dbcreatedate[$thishost] = "";

  $oraup_arclog[$thishost] = "";

  $dbarole        = "";
  $dbarole_cnt    = 0;
  $userpw        = "";
  $userpw_cnt    = 0;
  $userpwchanged = "";
  $userpwchanged_cnt    = 0;
  $userpwsys        = "";
  $userpwsys_cnt    = 0;

  $unrecdf_list     = "";
  $unrecdf_cnt      = 0;

  $up_arclogmode    = "";
  $up_logswitchwait = "";
  $up_archiver      = "";

  undef @orphan_dfs;
  $orphan_size = 0;

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;

    #
    # Start of stack processing
    #

    if (index($F0,"Stack:") == -1)
    {
      $oraBkupStack[$thishost] .= $F0;   # Save all of this file for the backup routine
    }

    if ($F1 eq "Stack:" && $F2 eq "oraSaveCfgStack")
    {
      $oraSaveCfgStack[$thishost] .= $F0;
      $diagLsnrStackFlag = 0;
    }

    if ($F1 eq "Stack:" && $F2 eq "oraAuditSes")
    {
      $oraAuditSesStack[$thishost] .= $F0;
      $diagAudSesStack = 1;
    }

    if ($F1 eq "Stack:" && $F2 eq "oraLsnrStack")
    {
      $oraLsnrStack[$thishost] .= $F0;
      $diagLsnrStackFlag = 1;
      ##print "$titleraw[$thishost] LsnrStack=$F0\n";
    }

    if ($F1 eq "Stack:" && $F2 eq "oraDatafilesStack")
    {
      $oraDatafilesStack[$thishost] .= $F0;
      $diagLsnrStackFlag = 0;
    }

    if ($F1 eq "Stack:" && $F2 eq "oraAlertsStack")
    {
      $oraAlertsStack[$thishost] .= $F0;
      $diagLsnrStackFlag = 0;
    }

    if ($diagLsnrStackFlag)
    {
      $diagLsnrStack[$thishost] .= $F0;
    }

    #
    # End of stack processing
    #

    if ($F0 =~ /END_OF_PROBE/)
    {
      &logit("DEBUG - END_OF_PROBE Found",$thishost);
      last; 
    }

    if ($F2 eq "PATCH:") 
    {
      $dp_patchnum    = (split('\|',$F0)) [1];
      $dp_ver         = (split('\|',$F0)) [2];
      $dp_dateapplied = (split('\|',$F0)) [3];
      $dp_whoapplied  = (split('\|',$F0)) [4];
      $dp_comment     = (split('\|',$F0)) [5];

      $dp_patchnum    =~ s/\s+$//;
      $dp_ver         =~ s/\s+$//;
      $dp_dateapplied =~ s/\s+$//;
      $dp_whoapplied  =~ s/\s+$//;
      $dp_comment     =~ s/\s+$//;

      ##print "dp_patchnum=$dp_patchnum dp_ver=$dp_ver dp_dateapplied=$dp_dateapplied dp_whoapplied=$dp_whoapplied dp_comment=$dp_comment\n";

      #---- If this is the first patch for this instance, then delete the
      #----   old rows before inserting.
      if ($sw_patchcount[$thishost] == 0)
      {
        &dbmsPatchCreate("D",$thishost);
      }

      #---- Insert this new row
      # my ($verb, $h, $dp_patchnum, $dp_ver, $dp_dateapplied, $dp_whoapplied, $dp_comment) = @_;
      &dbmsPatchCreate("I",
        $thishost,
        $dp_patchnum,
        $dp_ver,
        $dp_dateapplied,
        $dp_whoapplied,
        $dp_comment);
    
      $sw_patchcount[$thishost]++;
    }

    if ($F2 eq "INHIBITED:") 
    {
      &event("I",$thishost,"DBAmon checking inhibited by ora_dbshut","InhShut","DBA301",$tmpfl3);
      $up[$thishost] = "I";
      return;
    }

    #---- Check for EM running
    #---- print "$P EM_STATUS: $em_status $em_started\n";
    if ($F2 eq "EM_STATUS:") 
    {
      $em_status = $F3;
      $em_started = $F4;
      if ($em_status eq "D")
      {
        &event("I",$thishost,"EM emctl Is configured, but Down - Restart failed (check probe output)","EMDown","DBA740",$tmpfl3);
      }
      if ($em_status eq "U" && $em_started eq "Y")
      {
        &event("U",$thishost,"EM emctl Was restarted OK","EMStarted","DBA740",$tmpfl3);
      }
    }

    #---- Check for isqlplus running
    #---- print "$P ISQ_STATUS: $isq_status $isq_started\n";
    if ($F2 eq "ISQ_STATUS:") 
    {
      $isq_status = $F3;
      $isq_started = $F4;
      if ($isq_status eq "D")
      {
        &event("I",$thishost,"iSQLPlus Is Down - Restart failed (check probe output)","iSQDown","DBA740",$tmpfl3);
      }
      if ($isq_status eq "U" && $isq_started eq "Y")
      {
        &event("U",$thishost,"iSQLPlus Was restarted OK","iSQStarted","DBA740",$tmpfl3);
      }
    }

    #---- Look for oddjob running
    if ($F2 eq "CRON_ODDJOB:" && $F3 == 0) 
    {
      &event("C",$thishost,"ora_oddjob Not found in crontab","OddjobMissing","DBA607",$tmpfl3);
    }

    #---- Look for oddjob running
    if ($F2 eq "CRON_SCHED:" && $F3 == 0) 
    {
      &event("C",$thishost,"ora_backup_sched Not found in crontab","OraBckSchedMissing","DBA608",$tmpfl3);
    }
    
    #---- Corruption
    if ($F2 eq "CORRUPTION_DETAILS:")
    {
      $corruption_details .= substr($F0,34); 
    }
    if ($F2 eq "CORRUPTION:")
    {
      open(TMPFL6, ">$tmpfl6") || &error_msg("Cannot open output $tmpfl6 - $!");
      print TMPFL6 $corruption_details;
      close(TMPFL6);
      &event("U",$thishost,"DB Block Corruption - $F3 Block segments","DBCorrupt","DBA940",$tmpfl6);
    }

    #---- DST2007 Logic
    # dbamon_ora.pl DST2007_JVM:           1
    # dbamon_ora.pl DST2007_TZ_COL_SYS:    1
    # dbamon_ora.pl DST2007_TZ_COL_NONSYS: 1

    if (0 == 1) #---- Old logic - turned off
    {
      if ($F2 eq "DST2007_JVM:"           && $F3 == 1) { &event("S",$thishost,"DST2007 ($sw_version[$thishost]) JVM Is installed","DST2007_JVM","DBA320",$tmpfl3); }
      if ($F2 eq "DST2007_TZ_COL_SYS:"    && $F3 == 1) { &event("S",$thishost,"DST2007 ($sw_version[$thishost]) SYS TZ Columns Founds","DST2007_Col_SYS","DBA321",$tmpfl3); }
      if ($F2 eq "DST2007_TZ_COL_NONSYS:" && $F3 == 1) { &event("S",$thishost,"DST2007 ($sw_version[$thishost]) Non-SYS TZ Columns Found","DST2007_Col_NonSYS","DBA322",$tmpfl3); }
    }
    # dbamon_ora.pl DST2007_COL_REQUIRED:     1
    # dbamon_ora.pl DST2007_JVM_REQUIRED:     0
    if (1 == 1)
    {
      if ($F2 eq "DST2007_COL_REQUIRED:" && $F3 == 1) { &event("W",$thishost,"DST2007 ($sw_version[$thishost]) TZ-Column Patch Required and Missing $F4","DST2007_COL","DBA323",$tmpfl3); }
      if ($F2 eq "DST2007_JVM_REQUIRED:" && $F3 == 1) { &event("W",$thishost,"DST2007 ($sw_version[$thishost]) JVM Patch Required and Missing","DST2007_JVM","DBA323",$tmpfl3); }
    }

    if ($F2 eq "TS_NO_DF:") 
    {
      if ($standby[$thishost] eq "STANDBY")
      { 
        $z = "(Standby DB)"; 
      }
      else
      { 
        $z = ""; 
      }
      
      &event("C",$thishost,"Tablespace(s) Found With NO Datafiles: $F3 $z","TSNoDFs","DBA317");
    }

    if ($F2 eq "REGISTRY_COMPONENT_OLD:") 
    {
      $rg_version   = (split('\|',$F0)) [1];
      $rg_status    = (split('\|',$F0)) [2];
      $rg_component = (split('\|',$F0)) [3];

      $zver = $sw_version[$thishost];
      $zver =~ s/^0//;

      &event("C",$thishost,"DBA_REGISTRY Shows that component ($rg_component) is at version $rg_version which is less than DB engine version $zver - rg_status=$rg_status","CompMisMatch","DBA918");
      ##system("echo ' ' | dbamon_mailer -s 'DBAmon $titleraw[$thishost] $F0' $admin_email");
    }

    if ($F2 eq "RMANDIAG:") 
    {
	open(RMANDIAG, ">>/opt/dbamon/log/dbamon_rmandiag.txt") || &error_msg("Can't open output log/dbamon_rmandiag.txt - $!");
	print RMANDIAG $F0;
	close(RMANDIAG);
    }

    if ($F2 eq "RMANHUNGMULTI:") 
    {
      $zmsg = "There are $F3 hung RMAN processes (PIDs: $F4)"; 
      &event("C",$thishost,"$zmsg","RMANHung","DBA912",$tmpfl3);
      ##system("echo ' ' | dbamon_mailer -m -s 'DBAmon $titleraw[$thishost] $F0' $admin_email");
    }

    if ($F2 eq "RMANKILLED:") 
    {
      $zmsg = "RMAN Process $F5 was automatically KILLED"; 
      &event("U",$thishost,"$zmsg","RMANKilled","DBA931",$tmpfl3);
    }

    if ($F2 eq "ORACLE_AUTOSTART:") 
    {
      if ($F3 eq "OBSOLETE") 
      {
	&event("W",$thishost,"The Oracle Autostart software (/sbin/init.d/oracle) is obsolete - it does not invoke oraadmin","AutoStartObsolete","DBA470",$tmpfl3);
      }
      if ($F3 eq "NF") 
      {
	&event("W",$thishost,"This server does not have Oracle Autostart configured - Start and/or Stop symlink missing","AutoStartMissing","DBA471",$tmpfl3);
      }
    }

    if ($F2 eq "LISTENER_LOG_SIZE:") 
    {
      &event("U",$thishost,"The Oracle Listener Log $F5 is $F3 MB (exceeds threshold of $F4 MB)","ListenerLogBig","DBA472",$tmpfl3);
    }
    if ($F2 eq "LISTENER_LOG_SAVINGS:") 
    {
      &event("U",$thishost,"The Oracle Listener Log was gzipped - $F3 MB saved","ListenerLogBig","DBA472",$tmpfl3);
      system("cat $tmpfl3 | dbamon_mailer -s 'DBAmon oraUp() $titleraw[$thishost] Listener Log Savings $F3' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
    }
    if ($F2 eq "LISTENER_LOG_GZIP_ERROR:") 
    {
      &event("C",$thishost,"Error gzipping Oracle Listener Log - $F0","ListenerLogErr","DBA472",$tmpfl3);
    }

    if ($F2 eq "AUTOEXTENDCNT:") 
    {
      $autoextend_cnt[$thishost] = $F3; 
      if ($autoextend_cnt[$thishost] > 0)
      {
        &event("C",$thishost,"DB Has $autoextend_cnt[$thishost] AUTOEXTEND=YES datafiles","AutoExt","DBA941");
        ##system("cat $tmpfl3 | dbamon_mailer -s 'DBAmon oraUp() $titleraw[$thishost] autoextend_cnt[$thishost]=$autoextend_cnt[$thishost]' $admin_email");
      }
    }

    if ($F2 eq "NUMUSERS:")   { $numusers[$thishost] = $F3; }
    if ($F2 eq "NUMUSERSND:") { $numusersnd[$thishost] = $F3; }
    if ($F2 eq "NUMPROFS:")   { $numprofs[$thishost] = $F3; }

    if ($F2 eq "COMPLEXPW:")   { $complexpw[$thishost] = $F3; }
    if ($F2 eq "DBCREATEDATE:")   { $dbcreatedate[$thishost] = $F3; }

    if ($F2 eq "GOOD_USERS_TS:") { $good_users_ts[$thishost] = $F3; }
    if ($F2 eq "GOOD_TEMP_TS:")  { $good_temp_ts[$thishost]  = $F3; }

    if ($F2 eq "ASM:")  { $asm[$thishost]  = $F3; }

    if ($F2 eq "BKUP_SCHED_ARC:")  { $bkup_sched_arc[$thishost]  = $F3; }
    if ($F2 eq "BKUP_SCHED_LVL:")  { $bkup_sched_lvl[$thishost]  = $F3; }

    if ($F2 eq "DF_TEMP_TS:")  { $df_temp_ts[$thishost]  = $F3; }
    if ($F2 eq "DF_PERM_TS:")  { $df_perm_ts[$thishost]  = $F3; }

    if ($F2 eq "OEMPORT:")  { $oemport[$thishost] = $F3; }
    if ($F2 eq "ISQLPORT:")  { $isqlport[$thishost] = $F3; }

    if ($F2 eq "ORPHANDF:") 
    {
      push @orphan_dfs, "Datafile=$F3 DaysSinceUpdate=$F4 SizeGb=$F5";
      $orphan_size += $F5;
    }

    if ($F2 eq "UNREC_RMAN_CHANGE:") 
    {
      if ($unrecdf_list eq "")
      {
        $unrecdf_list =  "<table border=1 bgcolor=wheat>
          <tr bgcolor=slate>
            <th>$f_s Datafile With UNRECOVERABLE Change $f_e
            <th>$f_s Date Of <br>UNRECOVERABLE Change $f_e
            <th>$f_s Date Of Most Recent <br>RMAN LVLx Backup $f_e
        \n"; 
      }
      $unrecdf_list .= "<tr><td>$f_s $F3 $f_e<td>$f_s $F4 $f_e<td>$f_s $F5 $f_e\n"; 
      $unrecdf_cnt++;
    }

    #---- Security events - START
    if ($F2 eq "DBAROLE:") 
    {
      $sec_dbarole[$thishost] .= "User=$F3\n"; 
      $sec_dbarole_cnt[$thishost]++;
    }

    if ($F2 eq "IMPROLE:") 
    {
      $sec_improle[$thishost] .= "User=$F3\n"; 
      $sec_improle_cnt[$thishost]++;
    }

    if ($F2 eq "AU_PRIV:") 
    {
      $sec_aupriv[$thishost] .= "User=$F3\n"; 
      $sec_aupriv_cnt[$thishost]++;
    }

    if ($F2 eq "USER=PW:") 
    {
      $sec_userpw[$thishost] .= "User=$F3\n"; 
      $sec_userpw_cnt[$thishost]++;
    }

    if ($F2 eq "USER=PW-CHANGED:") 
    {
      $sec_userpwchanged[$thishost] .= "User=$F3\n"; 
      $sec_userpwchanged_cnt[$thishost]++;
    }

    if ($F2 eq "USER=PW-SYS:") 
    {
      $sec_userpwsys[$thishost] .= "User=$F3\n"; 
      $sec_userpwsys_cnt[$thishost]++;
    }

    if ($F1 eq "instanceDetails:") 
    {
      $instance_details[$thishost] .= "|$F2|$F3|$F4|\n"; 
    }

    if ($F2 eq "ORAFILEPERM:") 
    {
      $sec_fileperm[$thishost] .= substr($F0,index($F0,"Event:")); 
      $sec_fileperm_cnt[$thishost]++;
    }

    #dbamon_ora.pl DBAGROUP_GROUP: dkreddy
    if ($F2 eq "DBAGROUP_GROUP:") 
    {
      $sec_dbagrp_g[$thishost] .= "User=$F3 (/etc/group)\n";
      $sec_dbagrp_g_cnt[$thishost]++;
    }

    if ($F2 eq "DBAGROUP_PASSWD:") 
    {
      $sec_dbagrp_p[$thishost] .= "User=$F3 (/etc/passwd)\n";
      $sec_dbagrp_p_cnt[$thishost]++;
    }
    #---- Security events - END

    if ($F2 eq "ARCLOGMODE:")   
    { 
      $oraup_arclog[$thishost] = $F3;
      $up_arclogmode           = $F3; 
    }

    #---- perfRedo output Start

    if ($F2 eq "Redo_1Day_Count:"   && $F3 ne "") { $redo_1day_count[$thishost] = $F3; next; }
    if ($F2 eq "Redo_1Day_PerHour:" && $F3 ne "") { $redo_1day_perhour[$thishost] = $F3; next; }
    if ($F2 eq "Redo_30Day_Avg_GB:" && $F3 ne "") { $redo_30day_avg_gb[$thishost] = $F3; next; }
    if ($F2 eq "Redo_30Day_Max_GB:" && $F3 ne "") { $redo_30day_max_gb[$thishost] = $F3; next; }
    if ($F2 eq "Redo_Archv_FS_GB:"  && $F3 ne "") { $redo_archv_fs_gb[$thishost] = $F3; next; }
    if ($F2 eq "Redo_Archv_FS:"     && $F3 ne "") { $redo_archv_fs[$thishost] = $F3; next; }
    if ($F2 eq "Redo_Archv_Ratio:"  && $F3 ne "") { $redo_archv_ratio[$thishost] = $F3; next; }
    if ($F2 eq "Redo_Log_Size:"     && $F3 ne "") { $redo_log_size[$thishost] = $F3; next; }

    #---- perfRedo output End

    if ($F2 eq "LOGSWITCHWAIT:") { $up_logswitchwait = $F3; }
    if ($F2 eq "ARCHIVER:")      { $up_archiver      = $F3; }

    if ($F2 eq "MTS_QUEUE:")      { $mts_queue[$thishost] = $F3; }
    if ($F2 eq "SYS_ANALYZED:")   { $sys_analyzed[$thishost] = $F3; }
    if ($F2 eq "UNDO_MGMT:")      { $undo_mgmt[$thishost] = $F3; }
    if ($F2 eq "FORCE_LOGGING:")  { $force_logging[$thishost] = $F3; }

    if ($F2 eq "TS_EXCEPTION:") 
    {
      $ts_exceptions[$thishost] .= "$F3,$F4,$F5,$F6,$F7 ";
    }

    if ($F2 eq "USER_EXCEPTION:") 
    {
      $user_exceptions[$thishost] .= "$F3,$F4,$F5,$F6,$F7 ";
    }

    if ($F2 eq "SHMSIZE:") 
    {
      $shmsize[$thishost] = $F3;
    }

    if ($F2 eq "Rollback_Waits_To_Gets:") 
    {
      $rollback_wtg[$thishost] = $F3;
    }

    if ($F2 eq "FILECHECK:") 
    {
      $fc_threshold = 28;
      $fc_verb = $F3;
      $fc_age  = $F5;
      $fc_file = $F6;
      if ($fc_verb eq "NotFound")
      {
        # BB 21Mar03 - Temp. change to prevent ticket - sev from C to W
        # BB 10Apr03 - Change back to C
        &event("C",$thishost,"FILECHECK File=$fc_file Not Found ","FileNF","DBA302",$tmpfl3,'NOTIX');
        ##system("echo ' ' | dbamon_mailer -m -s 'DBAmon $title[$thishost] FILECHECK NF fc_verb=$fc_verb fc_file=$fc_file fc_age=$fc_age' $admin_email");
        chop($datew = `date +%C%y/%m/%d-%H:%M:%S`);
        system("echo '$datew - FILECHECK NF  $title[$thishost] fc_verb=$fc_verb fc_file=$fc_file fc_age=$fc_age' >> /tmp/dbamon_filecheck.txt");
      }
      if ($fc_age > $fc_threshold)
      {
	$r1 = int($fc_age / 10);
	$r1 = $r1 * 10;
	$r2 = $r1 + 9;
        $fc_age_rounded = "${r1}-${r2}";

        # BB 21Mar03 - Temp. change to prevent ticket - sev from C to W
        # BB 27May03 - Change back
        &event("C",$thishost,"FILECHECK File=$fc_file Is $fc_age_rounded Hours Old (> $fc_threshold Threshold)","FileOld","DBA303",$tmpfl3);

        ## &event("C",$thishost,"FILECHECK File=$fc_file Is $fc_age_rounded Hours Old (> $fc_threshold Threshold)","FileOld","DBA303",$tmpfl3,'NOTIX');
        ## ##system("echo ' ' | dbamon_mailer -m -s 'DBAmon $title[$thishost] FILECHECK AGE fc_verb=$fc_verb fc_file=$fc_file fc_age=$fc_age' $admin_email");
        ## chop($datew = `date +%C%y/%m/%d-%H:%M:%S`);
        ## #run the tools distribution to the target host to update tools 
        ## if ($comm_method[$thishost] eq 'ssh')  
        ##  {
        ##   $exestr = '/usr/local/dba/tools/tools_transmit $thishost $userid[$thishost]' ; 
        ##  }
        ## else
        ##  {
        ##   $exestr = '/usr/local/dba/tools/tools_transmit_rcp $thishost $userid[$thishost]'  ;
        ##  }
        ## #system("$exestr &) ;  
        ## logit("Executing $exestr",$thishost) ; 
        ## system("echo '$datew - FILECHECK AGE $title[$thishost] fc_verb=$fc_verb fc_file=$fc_file fc_age=$fc_age' >> /tmp/dbamon_filecheck.txt");

      }
    }

    if ($F2 eq "ORACRASHED:")  
    { 
      chop($z = substr($F0,26));
      &event("$eventsev",$thishost,"Oracle Crashed - $z","OraCrash","DBA603",$tmpfl3);
      ##system("echo ' ' | dbamon_mailer -m -s 'DBAmon OraCrash Detected For: $title[$thishost] - $z' $dbamon_admin");
    }

    if ($F2 eq "ONLINEREDOSTATUS:")  
    { 
      &event("C",$thishost,"Online Redo Log $F2 $F3 In Exception Status","RedoStat","DBA604C",$tmpfl3);
      ##system("echo ' ' | dbamon_mailer -m -s 'DBAmon Online Redo Log $F2 $F3 In Exception Status - $title[$thishost] - $z' $dbamon_admin");
    }

    if ($F2 eq "PROCESSES_THRESHOLD:")  
    { 
      $p_current = $F3;
      $p_config  = $F4;
      $p_pct = int(($p_current / $p_config) * 100) if $p_config > 0;

      if    ($p_pct >= 95) { $p_sev = "C"; }
      elsif ($p_pct >= 90) { $p_sev = "W"; }
      else                 { $p_sev = ""; }
     
      if ($p_sev)
      {
        &event("$p_sev",$thishost,"Oracle PROCESSES - Current Count: $p_current - INIT.ORA Value: $p_config - Percent Used: ${p_pct}%","ProcCount","DBA605",$tmpfl3);
      }
    }

    if ($F2 eq "FILES_THRESHOLD:")  
    { 
      $f_current = $F3;
      $f_config  = $F4;
      $f_pct = int(($f_current / $f_config) * 100) if $f_config > 0;

      if    ($f_pct >= 95) { $f_sev = "C"; }
      elsif ($f_pct >= 90) { $f_sev = "W"; }
      else                 { $f_sev = ""; }
     
      #---- IMPL ---- remove later
      ##$f_sev = "U" if $f_pct >= 95;

      if ($f_sev)
      {
        &event("$f_sev",$thishost,"Oracle DB_FILES - Current Count: $f_current - INIT.ORA Value: $f_config - Percent Used: ${f_pct}%","FilesCount","DBA606",$tmpfl3);
      }
    }

    if ($F2 eq "HOSTNAME:")   { $rmt_hostname[$thishost] = $F3 }
    if ($F2 eq "FQHOSTNAME:") { $rmt_fqhostname[$thishost] = $F3 }
    if ($F2 eq "NETALIAS:")   { $rmt_netalias_list[$thishost] .= "${F3}," }

    if ($F3 eq "FQHOST:")   { $urlfqhost[$thishost] = $F4 }
    if ($F2 eq "SQLGOOD:")  { $sqlworks = $F3 }
    if ($F2 eq "ORAVER:")   
    { 
      $sw_version[$thishost] = $F3;
      $sw_version[$thishost] = "0" . $F3 if substr($F3,0,1) gt "2";
      $sw_version_num[$thishost] = $sw_version[$thishost] + 0;
    }

    if ($F2 eq "Num_Cron:")  { $num_cron[$thishost]  = $F3 }

    if ($F2 eq "NUMPMON:")  { $numpmon  = $F3 }
    if ($F2 eq "NUMSMON:")  { $numsmon  = $F3 }
    if ($F2 eq "NUMLGWR:")  { $numlgwr  = $F3 }
    if ($F2 eq "NUMDBWR:")  { $numdbwr  = $F3 }
    if ($F2 eq "NUMIOSLAVE:")  { $numioslave  = $F3 }

    if ($F2 eq "TOT_FSSIZE_GB:")  { $tot_fssize_gb[$thishost]  = $F3 }
    if ($F2 eq "TOT_FSUSED_GB:")  { $tot_fsused_gb[$thishost]  = $F3 }
    if ($F2 eq "TOT_FSFREE_GB:")  { $tot_fsfree_gb[$thishost]  = $F3 }
    if ($F2 eq "MAX_FSFREE_GB:")  { $max_fsfree_gb[$thishost]  = $F3 }
    if ($F2 eq "PCT_FSUSED:")     { $pct_fsused[$thishost]  = $F3 }

    if ($F2 eq "NUM_OTRACE:")  { $num_otrace[$thishost] = $F3 }
    if ($F2 eq "SQL_TRACE:")   { $sql_trace[$thishost] = $F3 }

    if ($F2 eq "LOGINS:")   { $logins  = $F3 }
    if ($F2 eq "ORACLE_STARTED:")   { $dbstarted = $F3 }
    if ($F2 eq "BKTYPE:")   { $backup_method_long[$thishost] = $F3 }
    if ($F2 eq "BACKUP_TYPE_MR:")   { $mr_backup_type[$thishost] = $F3 }
    if ($F2 eq "BACKUP_DATE_MR:")   { $mr_backup_date[$thishost] = $F3 }
    if ($F2 eq "UPTIME:") 
    {
      $str_c = $F3;
      $str_n = $F4;
      $end_c = $F5;
      $end_n = $F6;
      &uptimeLog($thishost);
    }
    if ($F2 eq "PARALLEL:") 
    {
      $ops[$thishost] = $F3;
      $inst_num[$thishost] = $F4;
    }
    if ($F2 eq "SGA:") 
    {
      $sga_pct[$thishost] = $F3;
      $sga_size[$thishost] = $F4;
      $sga_free[$thishost] = $F5;
      ##print "$title[$thishost] sga_pct=$sga_pct[$thishost] sga_size=$sga_size[$thishost] sga_free=$sga_free[$thishost]\n";
      $sga_pct[$thishost] = sprintf("%.2f", $sga_pct[$thishost]);
    }
    if ($F2 eq "BUFFER_CACHE_SIZE:") 
    {
      $buffer_cache_size[$thishost] = $F3;
    }
    
    if ($F2 eq "STANDBY:") 
    {
      $standby[$thishost] = $F3
    }
    ##print "DEBUG: F2=$F2 standby=$standby[$thishost] F0=$F0";

    if ($F2 eq "DBID:") 
    {
      $dbid[$thishost] = $F3
    }
    if ($F2 eq "DBSTATUS:") 
    {
      $dbstatus[$thishost] = $F3
    }
    if ($F2 eq "CFTYPE:") 
    {
      $cftype[$thishost] = $F3
    }
    if ($F2 eq "MAXPROCESSES:") 
    {
      $maxprocesses = 1;
      $maxprocesscnt = $F3;
    }
    if ($F2 eq "SESSIONSHWM:") 
    {
      $sessionshwm[$thishost] = $F3;
      &histCreate("oraUp()",$thishost,"STA","sessionshwm",$sessionshwm[$thishost]);
    }

    if ($F2 eq "BUFCONGETS:")     { $bufcongets[$thishost] = $F3; }
    if ($F2 eq "BUFBLKGETS:")     { $bufblkgets[$thishost] = $F3; }
    if ($F2 eq "BUFPHYSREADS:")   { $bufphysreads[$thishost] = $F3; }
    if ($F2 eq "BUFHITRATIO_XR:") { $bufhitratio_xr[$thishost] = sprintf("%.2f", $F3); } 
    if ($F2 eq "BUFHITRATIO:") 
    {
      if ($bufphysreads[$thishost] =~ /^1.844/ && $pool_default_hr[$thishost] > 0)
      {
        $bufhitratio[$thishost] = $pool_default_hr[$thishost];
      }
      else
      {
        $bufhitratio[$thishost] = $F3;
      }
      &histCreate("oraUp()",$thishost,"PER","bufhitratio",$bufhitratio[$thishost]);
    }

    if ($F2 eq "LIBHITRATIO:") 
    {
      $libhitratio[$thishost] = $F3;
      &histCreate("oraUp()",$thishost,"PER","libhitratio",$libhitratio[$thishost]);
    }

    if ($F2 eq "LIBGETS:") 
    {
      $libgets[$thishost] = $F3;
    }

    if ($F2 eq "DICTHITRATIO:") 
    {
      $dicthitratio[$thishost] = $F3;
      &histCreate("oraUp()",$thishost,"PER","dicthitratio",$dicthitratio[$thishost]);
    }

    if ($F2 eq "DICTGETS:") 
    {
      $dictgets[$thishost] = $F3;
    }

    if ($F2 eq "ASYNCIO:") 
    {
      $asyncio[$thishost] = $F3;
    }

    if ($F2 eq "DB_BLOCK_BUFFERS:") 
    {
      $db_block_buffers[$thishost] = $F3;
    }

    if ($F2 eq "DB_BLOCK_SIZE:") 
    {
      $db_block_size[$thishost] = $F3;
    }

    if ($F2 eq "FREE_BUFFERS:") 
    {
      $free_buffers[$thishost] = $F3;
      ##print "$titleraw[$thishost] fb=$free_buffers[$thishost] F3=$F3\n";
    }

    if ($F2 eq "SPFILE:") 
    {
      $spfile[$thishost] = $F3;
      ##print "$titleraw[$thishost] spfile=$spfile[$thishost] F3=$F3\n";
    }

    if ($F2 eq "DB_CACHE_SIZE:") 
    {
      $db_cache_size[$thishost] = $F3;
    }

    if ($F2 eq "GRANULE_SIZE:") 
    {
      $granule_size[$thishost] = $F3;
    }

    #---- See how many controlfiles we have - s/b 3 
    if ($F2 eq "CF_ROWS:") 
    {
      $cf_rows = $F3;
      if ($df_t_cf_min && $cf_rows > 0 && $cf_rows < $df_t_cf_min)
      {
        &event("C",$thishost,"You only have $cf_rows controlfile(s) - You should have at least $df_t_cf_min","CF-Count","DBA659");
        system("echo '' | dbamon_mailer -s 'DBAmon oraUp() $titleraw[$thishost] cf_rows=$cf_rows' $admin_email") if $debug_659;
      }
    }

    #---- DFCOUNT vs. 1022 max 
    #----   dbamon_ora.pl TSDFCOUNT: PSAPSR3 959 93.84
    if ($F2 eq "TSDFCOUNT:") 
    {
      $zts   = $F3;
      $zdfc  = $F4;
      $zpct  = $F5;
      if ($zpct >= $t_dfcount_pct_c[$thishost])
      {
        &event("C",$thishost,"Tablespace $zts Datafile Count $zdfc Approaching Maxiumum of 1022 (${zpct}%) - Thresholds W/C $t_dfcount_pct_w[$thishost]/$t_dfcount_pct_c[$thishost] (C)","DF-Count","DBA680");
        system("echo '' | dbamon_mailer -s 'DBAmon oraUp() DFCOUNT-C $titleraw[$thishost] zpct=$zpct' $admin_email"); 
      }
      elsif ($zpct >= $t_dfcount_pct_w[$thishost])
      {
        &event("W",$thishost,"Tablespace $zts Datafile Count $zdfc Approaching Maxiumum of 1022 (${zpct}%) - Thresholds W/C $t_dfcount_pct_w[$thishost]/$t_dfcount_pct_c[$thishost] (W)","DF-Count","DBA680");
        system("echo '' | dbamon_mailer -s 'DBAmon oraUp() DFCOUNT-W $titleraw[$thishost] zpct=$zpct' $admin_email"); 
      }
    }

    # See if there are any LAN half-duplex events
    if ($F2 eq "HALF_DUPLEX_LAN:") 
    {
      $lancard = $F3;
      $lanmsg  = "$F4 $F5 $F6 $F7 $F8 $F9 $F10 $F11";
      &event("P",$thishost,"LAN Interface $lancard is in Half-Duplex mode ($lanmsg)","LAN-Half-Dup","DBA690");
      system("echo '' | dbamon_mailer -s 'DBAmon oraUp() $titleraw[$thishost] LAN $lancard is in Half-Duplex ($lanmsg)' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
      $landisplay .= "<tr><td><b>$f_s $lancard</b><td>$f_s $lanmsg\n"; 
    }
    if ($F2 eq "FULL_DUPLEX_LAN:") 
    {
      $lancard = $F3;
      $lanmsg  = "$F4 $F5 $F6 $F7 $F8 $F9 $F10 $F11";
      $landisplay .= "<tr><td><b>$f_s $lancard</b><td>$f_s $lanmsg\n"; 
    }

    if ($F2 eq "POOL_DEFAULT_HR:") { $pool_default_hr[$thishost] = $F3; }
    if ($F2 eq "POOL_RECYCLE_HR:") { $pool_recycle_hr[$thishost] = $F3; }
    if ($F2 eq "POOL_KEEP_HR:")    { $pool_keep_hr[$thishost] = $F3; }

    if ($F2 eq "Memory_Size_GB:")    { $hw_memory_size_gb[$thishost] = $F3; }
    if ($F2 eq "Memory_Free_GB:")    { $hw_memory_free[$thishost] = $F3; }
    if ($F2 eq "Memory_Pct_Full:")   { $hw_memory_pct_full[$thishost] = $F3; }

    if ($F2 eq "TIMESTAMP_ROWS:") 
    {
      $timestamp_rows[$thishost] = $F3;
    }

    if ($F2 eq "HOMEFULL:") 
    {
      $homefull[$thishost] = $F3;
      $homeflag[$thishost] = $F4;
    }
    if ($F1 eq "MODE" && $F2 ne "getconf")
    {
      $os_mode[$thishost] = $F2 if $F2 > 0;
    }

    if ($F2 eq "Server_Model:")     { $hw_model[$thishost] = $F3 }
    if ($F2 eq "Physical_RAM_MB:")  { $hw_memory[$thishost] = $F3 }
    if ($F2 eq "Num_Processors:")   { $hw_processors[$thishost] = $F3 }

    if ($F2 eq "CRONLINES:")   { $cronlines[$thishost] = $F3 }

    if ($F1 eq "Linux")
    {
      $os[$thishost] = "Linux";
      $os_version[$thishost] = substr($F3,0,3);
      $hw_model[$thishost] = $F12;
    }
    if ($F1 eq "HP-UX")
    {
      $os[$thishost] = "HP-UX";
      $os_version[$thishost] = substr($F3,2);
    }
    if ($F1 =~ /Sun/)
    {
      $os[$thishost] = "Solaris";
      if (index($F0,"5.9")  > -1) { $os_version[$thishost] = "9";  }
      if (index($F0,"5.10") > -1) { $os_version[$thishost] = "10"; }
    }
    if ($F2 eq "NFILE:")
    {
      $nf_cur[$thishost] = $F3;
      $nf_max[$thishost] = $F4;
      $nf_pct[$thishost] = $F5;
    }
    if ($F2 eq "NUSERPROC:")
    {
      $os_nuserproc[$thishost] = $F3;
      $os_maxuprc[$thishost] = $F4;
      $os_nuserproc_pct[$thishost] = $F5;
    }
    if ($F2 eq "BACKUP_AGE:")
    {
      if ($F3 eq "FRA")  { $mr_age_arc[$thishost]  = $F4; }
      if ($F3 eq "ARC")  { $mr_age_arc[$thishost]  = $F4; }
      if ($F3 eq "LVL0") { $mr_age_lvl0[$thishost] = $F4; }
      if ($F3 eq "FRALVL0") { $mr_age_lvl0[$thishost] = $F4; }
      if ($F3 eq "LVL1") { $mr_age_lvl1[$thishost] = $F4; }
      if ($F3 eq "FRALVL1") { $mr_age_lvl1[$thishost] = $F4; }
      if ($F3 eq "EXP")  { $mr_age_exp[$thishost]  = $F4; }
      if ($F3 eq "FULL") { $mr_age_full[$thishost] = $F4; }
      if ($F3 eq "BCV")  { $mr_age_bcv[$thishost]  = $F4; }
      if ($F3 eq "OFFLINE")  
      { 
        $mr_age_off[$thishost]  = $F4;
        $mr_age_lvl0[$thishost]  = $F4;
      }

      if ($F3 ne "ARC" and $F4 < $mr_age[$thishost])
      {
        $mr_age[$thishost] = $F4;
      }
    }


    if ($F2 eq "BACKUP_AGE_FILE:" && $NF == 10)
    {
      ##print "DEBUG here\n";
      if ($F4 eq "ARC")     { $mr_age_file_arc[$thishost]  = $F10 }
      if ($F4 eq "LVL0")    { $mr_age_file_lvl0[$thishost] = $F10 }
      if ($F4 eq "LVL1")    { $mr_age_file_lvl1[$thishost] = $F10 }
      if ($F4 eq "OFFLINE") { $mr_age_file_offline[$thishost] = $F10 }

      #if ($F4 ne "ARC" and $F10 < $mr_age[$thishost])
      if ($F4 ne "ARC")
      {
        $mr_age_file[$thishost] = $F10;
      }
    }
    if ($F2 eq "BACKUP_AGE_MR:")  
    { 
      $mr_age_lvl[$thishost] = $F3;
    }
    if ($F2 eq "BACKUP_RUNNING:") { $backup_running[$thishost] = $F3 }

    #if ($F2 eq "PARMERROR:") 
    #{ 
    #  $z = substr($F0,25);  # Message txt
    #  &event("W",$thishost,"init.ora Error: $z","ParmErr","DBA649",$tmpfl3);
    #}

    if (substr($F1,0,4) eq "9000")
    {
      @words = split(/\//,$F0);
      $model = $words[2];
      $model =~ s/ //g;
      $hw_model[$thishost] = $model;
    }
  }
  close(TMPFL3);
  
  #If this is a standby DB and we found the DBAmon bck age file, that
  #will be the age that we use

  if ($standby[$thishost] eq "STANDBY" && $mr_age_file[$thishost] != -1) 
  {
    $mr_age[$thishost] = $mr_age_file[$thishost];
  }
  ##print "$title[$thishost] standby=$standby[$thishost] mr_age_file=$mr_age_file[$thishost] mr_age=$mr_age[$thishost]\n";

  #if ($backup_method_long[$thishost] eq "bkNone" && $backup_age[$thishost] eq "N")
  if ($backup_age[$thishost] eq "N")
  {
    $backup_method_long[$thishost] = "bkDBCOff";
  }

  if ($sw_version[$thishost] ne "" && $sqlworks eq "1")
  {
    if ($sw_version[$thishost] lt $ver_oracle_low  || $ver_oracle_low eq "" ) { $ver_oracle_low  = $sw_version[$thishost] }
    if ($sw_version[$thishost] gt $ver_oracle_high || $ver_oracle_high eq "") { $ver_oracle_high = $sw_version[$thishost] }
  }

  $reason = "";

  if ($dbstatus[$thishost] ne "OPEN" && 
      $dbstatus[$thishost] ne "") 
  { 
    $reason .= "(DBStatus=$dbstatus[$thishost])(CFType=$cftype[$thishost])" 
  }
  if ($maxprocesses)    { $reason .= "(Max Processes Exceeded)" }
  if ($sqlworks ne "1") { $reason .= "(SQL Will Not Run)" }
  if ($numpmon  ne "1") { $reason .= "(PMON Not Running)" }
  if ($numsmon  ne "1") { $reason .= "(SMON Not Running)" }

  # Add more here

  if ($reason ne "")
  {
    $up[$thishost] = "N";

    if ($maxprocesses)
    {
      &event("$eventsev",$thishost,"Oracle Max Processes Exceeded: $reason","MaxProc","DBA601",$tmpfl3);
    }
    else
    {
      if ($conshort ne "Undiagnosed")
      {
        $reason = "ConnectionError=$conshort + $reason"; 
      }

      if ($orasid[$thishost] =~ /\+ASM/ && $dbstatus[$thishost] eq "STARTED")
      {
        &logit("STARTED Status OK for +ASM instance",$thishost);
        $up[$thishost] = "Y";
      }
      else
      {
	#---- If this is a mounted standby db, then only make a warning event
	if ($eventsev eq "C" && $cftype[$thishost] eq "STANDBY" && $dbstatus[$thishost] eq "MOUNTED") { $eventsev = "W"; }
	&event("$eventsev",$thishost,"Oracle Not Active/DB Not Open: $reason","Down($dbstatus[$thishost])","DBA602",$tmpfl3);
      }
    }
  }
  else
  {
    $up[$thishost] = "Y";
    logit("OK",$thishost);

    # See if the home dir is full
    if ($homeflag[$thishost] eq "C")
    {
      &event("$eventsev",$thishost,"Oracle ORACLE_HOME FS Is Full/Almost Full ({$homefull[$thishost]}%)","HomeFull","DBA640",$tmpfl3);
    }
  }

  if ($logins eq "RESTRICTED")
  {
    &event("$eventsev",$thishost,"Oracle In RESTRICTED SESSION Mode:","RestSess","DBA631",$tmpfl3);
  }

  if ($numioslave > 0)
  {
    $maxioslave_cnt = 35;
    $maxioslave_pct = 90;

    $numioslave_pct = int(($numioslave / $maxioslave_cnt) * 100);
    if ($numioslave_pct >= $maxioslave_pct)
    {
      &event("U",$thishost,"IO Slave Count Of $numioslave Is >= $numioslave_pct% of $maxioslave_cnt Maximum","IOSlaveCnt","DBA955",$tmpfl3);
    }
  }

  if ($cronlines[$thishost] ne "" && $cronlines[$thishost] == 0)
  {
    &event("C",$thishost,"User=$userid[$thishost] crontab is empty","CronEmpty","DBA661",$tmpfl3);
  }

  if ($num_cron[$thishost] ne "" && $num_cron[$thishost] == 0)
  {
    &event("W",$thishost,"Server cron Daemon does not appear to be running - num_cron=$num_cron[$thishost]","CronDead","DBA956",$tmpfl3);
  }

  if ($shmsize[$thishost])
  {
    $total_shmem[$thishost] = $shmsize[$thishost]; 
  }
  else
  {
    $total_shmem[$thishost] = int($sga_size[$thishost]/(1024*1024)) + $buffer_cache_size[$thishost]; 
  }

  #---- Read star_contacts
  &readCMDBContacts($thishost) if $rmt_hostname[$thishost] ne $hostfix[$thishost]; 

  #---- WWW Output
  &logDetails($thishost,"<h3>Oracle Instance Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");

  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Up?<td align=right>$f_s $up[$thishost]<td>$f_s (Y or N)");
  &logDetails($thishost,"<tr><td>$f_s <b>DB Status:<td align=right>$f_s $dbstatus[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>ORACLE_SID:<td align=right>$f_s $orasid[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>ORACLE_HOME:<td align=right>$f_s $orahome[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Version:<td align=right>$f_s $sw_version[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Started:<td align=right>$f_s $dbstarted");
  &logDetails($thishost,"<tr><td>$f_s <b>DB Logins?<td align=right>$f_s $logins");
  &logDetails($thishost,"<tr><td>$f_s <b>Concurrent Sessions HWM:<td align=right>$f_s $sessionshwm[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>ORACLE_HOME File System % Full:<td align=right>$f_s $homefull[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>ORACLE_HOME File System Status Flag:<td>$f_s $homeflag[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Backup Method:<td align=right>$f_s $backup_method_long[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Backup Running Now?:<td align=right>$f_s $backup_running[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Type:<td align=right>$f_s $mr_backup_type[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Date:<td align=right>$f_s $mr_backup_date[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - ARC Backup:<td align=right>$f_s $mr_age_arc[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - BCV Backup:<td align=right>$f_s $mr_age_bcv[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - OFFLINE Backup:<td align=right>$f_s $mr_age_off[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - OFFLINE Backup (From File):<td align=right>$f_s $mr_age_file_offline[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - LVL0 Backup:<td align=right>$f_s $mr_age_lvl0[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - LVL1 Backup:<td align=right>$f_s $mr_age_lvl1[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age - All Backup Types:<td align=right>$f_s $mr_age[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Most Recent Backup Age (from file - Standby):<td align=right>$f_s $mr_age_file[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Backup Schedule Present - ARC*?:<td align=right>$f_s $bkup_sched_arc[$thishost]<td>$f_s (True or False)");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Backup Schedule Present - LVL*?:<td align=right>$f_s $bkup_sched_lvl[$thishost]<td>$f_s (True or False)");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle RAC Mode?:<td align=right>$f_s $ops[$thishost]<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle RAC Instance Number:<td align=right>$f_s $inst_num[$thishost]<td>");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Standby Mode?:<td align=right>$f_s $standby[$thishost]<td>$f_s (CURRENT or STANDBY)");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle DBID:<td align=right>$f_s $dbid[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Current Process Count:<td align=right>$f_s $p_current");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle init.ora 'processes' Value:<td align=right>$f_s $p_config");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Processes % Used:<td align=right>$f_s $p_pct");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Processes % Used Severity:<td align=right>$f_s $p_sev<td>$f_s W, C or (Blank)");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Current File Count:<td align=right>$f_s $f_current");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle init.ora 'db_files' Value:<td align=right>$f_s $f_config");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Files % Used:<td align=right>$f_s $f_pct");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle Files % Used Severity:<td align=right>$f_s $f_sev<td>$f_s W, C or (Blank)");
  &logDetails($thishost,"<tr><td>$f_s <b>Filecheck Age:<td align=right>$f_s $fc_age");
  &logDetails($thishost,"<tr><td>$f_s <b>Filecheck Threshold:<td align=right>$f_s $fc_threshold");
  &logDetails($thishost,"<tr><td>$f_s <b>Timestamp Rows:<td align=right>$f_s $timestamp_rows[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Controlfile Count:<td align=right>$f_s $cf_rows");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle IO Slave Processes:<td align=right>$f_s $numioslave");
  &logDetails($thishost,"<tr><td>$f_s <b>Oracle IO Slave % of Max $maxioslave_cnt:<td align=right>$f_s $numioslave_pct%");
  &logDetails($thishost,"<tr><td>$f_s <b>DB_BLOCK_SIZE:<td align=right>$f_s $db_block_size[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>SPFILE:<td align=right>$f_s $spfile[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Shared Memory Size: <td align=right>$f_s $shmsize[$thishost] <td>$f_s (MB)");
  &logDetails($thishost,"<tr><td>$f_s <b>Total Instance Shared Memory: <td align=right>$f_s $total_shmem[$thishost] <td>$f_s (MB)");
  &logDetails($thishost,"<tr><td>$f_s <b>Buffer Cache Total Size: <td align=right>$f_s $buffer_cache_size[$thishost] <td>$f_s (MB)");
  &logDetails($thishost,"<tr><td>$f_s <b>Up Sample - Archivelog Mode:<td>$f_s $oraup_arclog[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>User Count:<td>$f_s $numusers[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>User Count Using Non-DEFAULT Profile:<td>$f_s $numusersnd[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>Non-Default Profile Count:<td>$f_s $numprofs[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>Complex Passwords Enforced:<td>$f_s $complexpw[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>DB Create Date:<td>$f_s $dbcreatedate[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>Autoextend=YES DF Count:<td>$f_s $autoextend_cnt[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>OEM emctl Status:<td>$f_s $em_status <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>OEM emctl Started?:<td>$f_s $em_started <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>iSQLPlus Status:<td>$f_s $isq_status <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>iSQLPlus Started?:<td>$f_s $isq_started <td>$f_s ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>CMDB Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>CMDB Contacts:<td>$f_s $star_contacts[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Redo Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>Last 24 Hours Archivelog Count:<td>$f_s $redo_1day_count[$thishost] ");
  &logDetails($thishost,"<tr><td>$f_s <b>Last 24 Hours Archivelog Rate:<td>$f_s  $redo_1day_perhour[$thishost] <td>$f_s Archivelogs/Hour");
  &logDetails($thishost,"<tr><td>$f_s <b>Last 30 Days Average:<td>$f_s  $redo_30day_avg_gb[$thishost] <td>$f_s GB/Day");
  &logDetails($thishost,"<tr><td>$f_s <b>Last 30 Days Max:<td>$f_s  $redo_30day_max_gb[$thishost] <td>$f_s GB/Day");
  &logDetails($thishost,"<tr><td>$f_s <b>Archivelog FS:<td>$f_s  $redo_archv_fs[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td>$f_s <b>Archivelog FS Size:<td>$f_s  $redo_archv_fs_gb[$thishost] <td>$f_s GB ");
  &logDetails($thishost,"<tr><td>$f_s <b>Last 30 Days Max Redo / Archivelog FS Size Ratio:<td>$f_s  $redo_archv_ratio[$thishost] <td>$f_s ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Type:<td align=right>$f_s $os[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Version:<td align=right>$f_s $os_version[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Mode:<td align=right>$f_s $os_mode[$thishost]<td>$f_s (32, 64 or Blank)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Type:<td align=right>$f_s $hw_model[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory:<td align=right>$f_s $hw_memory[$thishost]<td>$f_s (mB)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory:<td align=right>$f_s $hw_memory_size_gb[$thishost]<td>$f_s (gB)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory Free (GB):<td align=right>$f_s $hw_memory_free[$thishost]$f_s <td>$f_s (gB)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory % Used:<td align=right>$f_s $hw_memory_pct_full[$thishost]%");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Processor Count:<td align=right>$f_s $hw_processors[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Cron Lines:<td align=right>$f_s $cronlines[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Hostname:<td align=right>$f_s $rmt_hostname[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>FQ Hostname:<td align=right>$f_s $rmt_fqhostname[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>User Process Count:<td align=right>$f_s $os_nuserproc[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Kernel MAXUPRC:<td align=right>$f_s $os_maxuprc[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>User Process Count vs. MAXUPRC:<td align=right>$f_s $os_nuserproc_pct[$thishost]%");
  &logDetails($thishost,"<tr><td>$f_s <b>Cron Daemon Count:<td align=right>$f_s $num_cron[$thishost]");
  &logDetails($thishost,"</table><hr>");

  if ($fs_check_mask[$thishost] ne "")
  {
    &logDetails($thishost,"<h3>FS Size Checking Data</h3>");
    &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
    &logDetails($thishost,"<tr><td><b>DBC FS_Check_Mask:<td align=right>$fs_check_mask[$thishost]");
    &logDetails($thishost,"<tr><td><b>Total FS Size:<td align=right>$tot_fssize_gb[$thishost](gB)");
    &logDetails($thishost,"<tr><td><b>Total FS Used Size:<td align=right>$tot_fsused_gb[$thishost](gB)");
    &logDetails($thishost,"<tr><td><b>Total FS Free Size:<td align=right>$tot_fsfree_gb[$thishost](gB)");
    &logDetails($thishost,"<tr><td><b>Max Free Space:<td align=right>$max_fsfree_gb[$thishost](gB)");
    &logDetails($thishost,"<tr><td><b>Total FS Percent Full:<td align=right>$pct_fsused[$thishost]%");
    &logDetails($thishost,"</table><hr>");

    if ($pct_fsused[$thishost] >= $fs_check_threshold[$thishost])
    {
      &event("U",$thishost,"The filesystem(s) that match $fs_check_mask[$thishost] are $pct_fsused[$thishost]% full (threshold : $fs_check_threshold[$thishost]%)","DBFSFull","DBA653", "", "", "$fs_check_email[$thishost]");
    }
  }

  if ($landisplay ne "")
  {
    &logDetails($thishost,"<h3>LAN Data</h3>");
    &logDetails($thishost,"<table border=1 bgcolor=antiquewhite>");
    &logDetails($thishost,"<tr bgcolor=slate><th>LAN Interface<th>Status</tr>");
    &logDetails($thishost,"$landisplay");
    &logDetails($thishost,"</table><hr>");
  }

  # Determine whether we have any hostname alias
  $alias_list[$thishost] = "";

  ##print "fqh=$fqhostname[$thishost] rmth=$rmt_hostname[$thishost] rmtn=$rmt_netalias_list[$thishost]\n";

  # First, see if net alias was used and hostname differs
  if ($fqhostname[$thishost] !~ /^$rmt_hostname[$thishost]/)
  {
    $alias_list[$thishost] .= "${rmt_hostname[$thishost]}.${serverloc[$thishost]},";
  }

  if ($auto_detect_aliases eq "Y")
  {
    # Next, see if non-alias was used and net alias differs
    @words= split(/,/,$rmt_netalias_list[$thishost]);
    foreach $alias (@words)
    {
      ##print "found rmt_netalias_list entry $alias\n";
      if ($fqhostname[$thishost] ne $alias)
      {
	$alias_list[$thishost] .= "${alias},";
      }
    }

    ##print "ali=$alias_list[$thishost] \n";

    if ($alias_list[$thishost] ne "")
    {
      &logDetails($thishost,"<h3>Hostname Alias(es)</h3>");
      &logDetails($thishost,"<table border=1>");
      &logDetails($thishost,"<tr bgcolor=slate><th>Alias Name</tr>");

      @words= split(/,/,$alias_list[$thishost]);
      foreach $word (@words)
      {
	&logDetails($thishost,"<tr><td><b>$word");
      }

      &logDetails($thishost,"</table><hr>");
    }
  }

  #---- DEBUG otrace problem
  if ($num_otrace[$thishost] > 0)
  {
    ##print "DEBUG - tr=$titleraw[$thishost]\n"; 
    system("cat $tmpfl3 | dbamon_mailer -s 'DBAmon-DEBUG oraUp() $titleraw[$thishost] num_otrace=$num_otrace[$thishost]' $admin_email") if $titleraw[$thishost] !~ /^e/;
    ##print "DEBUG - HIT\n" if $titleraw[$thishost] !~ /^e/;
  }

  #---- Read SWVer data

  ($this_sw_version = $sw_version[$thishost]) =~ s/^0//g;

  foreach $swver_this (@swver_data) 
  {
    ##print "t=$titleraw[$thishost] d=$dbmsout[$thishost] line=$swver_this\n";

    if ($swver_this !~ /^$dbmsout[$thishost]/)
    {
      next;
    }

    @words = split(/ /,$swver_this);
    $this_family = $words[1];
    $this_minver = $words[2];

    ##print "$titleraw[$thishost] $this_sw_version - Found this_family=$this_family this_minver=$this_minver\n";

    # Continue only if this is OUR family
    next if $this_sw_version !~ /^$this_family/;

    $z = length($this_minver);
    if (substr($this_sw_version,0,$z) lt $this_minver)
    {
      &event("U",$thishost,"$dbmsout[$thishost] Version $this_sw_version is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
    }
  }

  # If this is a standby DB, then we don't want to save any user or ts exceptions
  if ($standby[$thishost] eq "STANDBY")
  {
    $ts_exceptions[$thishost] = "";
    $user_exceptions[$thishost] = "";
  }

  if ($unrecdf_list ne "" && $backup_age[$thishost] ne "N")
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL6 $unrecdf_list;
    print TMPFL6 "</table>\n";
    close(TMPFL6);
    &event("U",$thishost,"There have been $unrecdf_cnt UNRECOVERABLE Datafile Changes since the last RMAN LVLx backup","RMAN-UNREC","DBA518",$tmpfl6);
    ##system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon $titleraw[$thishost] $unrecdf_cnt UNRECOVERABLE Datafile Changes since the last RMAN Full backup' $admin_email");
  }

  if ($g_spfile eq "Y" && $spfile[$thishost] ne "" && $asm[$thishost] ne "YES")
  {
    &event("W",$thishost,"This Oracle instances uses SPFILE - spfile=$spfile[$thishost]","SPFile","DBA399",$tmpfl6);
  }

  if ($orphan_dfs[0])
  {
    open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
    foreach $dfline (@orphan_dfs)
    {
      print TMPFL6 "$dfline\n";
    }
    print TMPFL6 "\n<b>\n";
    print TMPFL6 "NOTE: These files have been verified to not exist in the Oracle data\n";
    print TMPFL6 "      dictionary (control files, online redo logs, datafiles, tempfiles)</b>\n";
    close(TMPFL6);
    $znum = $#orphan_dfs + 1;

    &event("U",$thishost,"There are $znum Possible Orphan Datafile(s) - $orphan_size gB (Threshold: 14 Days Since Last Update)","OrphanDFs-${orphan_size}gB","DBA313",$tmpfl6);

    ##system("cat $tmpfl6 | dbamon_mailer -s 'DBAmon DBA313 $titleraw[$thishost] $znum Possible Orphan Datafile(s) - $orphan_size gB' $admin_email") if $orphan_size > 10;
  }

  if ($up_arclogmode eq "ARCHIVELOG" && $up_archiver eq "STOPPED")
  {
    &event("C",$thishost,"DB is in ARCHIVELOG mode, but the archiver is STOPPED","ArcStopped","DBA308");
  }

  if ($up_logswitchwait eq "ARCHIVE_LOG")
  {
    &event("C",$thishost,"Instance is HUNG waiting for ARCHIVER process to finish (All ONLINE REDO LOGS are full)","RedoHANG","DBA309",$tmpfl3);
    $up[$thishost] = "N";
  }

  # Test
  ##print "Test 1 - $title[$thishost] $sw_version[$thishost] \n";
  ##print "ue=$user_exceptions[$thishost]\n";
  ##print "TestAud diagAudSesStack=$diagAudSesStack\n"; 
}
# -----------------------------------------------------------------------------
1;
